# coding: utf-8

"""
    Form Service API

    A list of form and Xaas APIs.  This page describes the RESTful APIs for Form Service. The APIs facilitate CRUD operations on the various resources and entities used throughout Form service (Custom Resource , Form Definition etc.) and allow operations on them (creating custom resource type , fetch form status etc.).  Some of the APIs that list collections of resources also support OData like implementation. Below query params can be used across Form and XaaS entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/form-service/api/custom/resource-types?$orderby=name%20DESC```  2. `page`, `size` - page used in conjunction with `size` helps in pagination of resources.      ```/form-service/api/custom/resource-types?page=0&size=20```   # noqa: E501

    OpenAPI spec version: 1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class FormserviceapiformsdesignerrunnableitemelementsInputBindings(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'input_key': 'str',
        'value': 'str',
        'type': 'FormserviceapiformsrendererexternalvaluesFieldType',
        'binding_action': 'FormserviceapiformsdesignerrunnableitemelementsBindingAction'
    }

    attribute_map = {
        'input_key': 'inputKey',
        'value': 'value',
        'type': 'type',
        'binding_action': 'bindingAction'
    }

    def __init__(self, input_key=None, value=None, type=None, binding_action=None):  # noqa: E501
        """FormserviceapiformsdesignerrunnableitemelementsInputBindings - a model defined in Swagger"""  # noqa: E501
        self._input_key = None
        self._value = None
        self._type = None
        self._binding_action = None
        self.discriminator = None
        if input_key is not None:
            self.input_key = input_key
        if value is not None:
            self.value = value
        if type is not None:
            self.type = type
        if binding_action is not None:
            self.binding_action = binding_action

    @property
    def input_key(self):
        """Gets the input_key of this FormserviceapiformsdesignerrunnableitemelementsInputBindings.  # noqa: E501


        :return: The input_key of this FormserviceapiformsdesignerrunnableitemelementsInputBindings.  # noqa: E501
        :rtype: str
        """
        return self._input_key

    @input_key.setter
    def input_key(self, input_key):
        """Sets the input_key of this FormserviceapiformsdesignerrunnableitemelementsInputBindings.


        :param input_key: The input_key of this FormserviceapiformsdesignerrunnableitemelementsInputBindings.  # noqa: E501
        :type: str
        """

        self._input_key = input_key

    @property
    def value(self):
        """Gets the value of this FormserviceapiformsdesignerrunnableitemelementsInputBindings.  # noqa: E501


        :return: The value of this FormserviceapiformsdesignerrunnableitemelementsInputBindings.  # noqa: E501
        :rtype: str
        """
        return self._value

    @value.setter
    def value(self, value):
        """Sets the value of this FormserviceapiformsdesignerrunnableitemelementsInputBindings.


        :param value: The value of this FormserviceapiformsdesignerrunnableitemelementsInputBindings.  # noqa: E501
        :type: str
        """

        self._value = value

    @property
    def type(self):
        """Gets the type of this FormserviceapiformsdesignerrunnableitemelementsInputBindings.  # noqa: E501


        :return: The type of this FormserviceapiformsdesignerrunnableitemelementsInputBindings.  # noqa: E501
        :rtype: FormserviceapiformsrendererexternalvaluesFieldType
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this FormserviceapiformsdesignerrunnableitemelementsInputBindings.


        :param type: The type of this FormserviceapiformsdesignerrunnableitemelementsInputBindings.  # noqa: E501
        :type: FormserviceapiformsrendererexternalvaluesFieldType
        """

        self._type = type

    @property
    def binding_action(self):
        """Gets the binding_action of this FormserviceapiformsdesignerrunnableitemelementsInputBindings.  # noqa: E501


        :return: The binding_action of this FormserviceapiformsdesignerrunnableitemelementsInputBindings.  # noqa: E501
        :rtype: FormserviceapiformsdesignerrunnableitemelementsBindingAction
        """
        return self._binding_action

    @binding_action.setter
    def binding_action(self, binding_action):
        """Sets the binding_action of this FormserviceapiformsdesignerrunnableitemelementsInputBindings.


        :param binding_action: The binding_action of this FormserviceapiformsdesignerrunnableitemelementsInputBindings.  # noqa: E501
        :type: FormserviceapiformsdesignerrunnableitemelementsBindingAction
        """

        self._binding_action = binding_action

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(FormserviceapiformsdesignerrunnableitemelementsInputBindings, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FormserviceapiformsdesignerrunnableitemelementsInputBindings):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
